package cn.estsh.i3plus.pojo.mes.pcn.bean;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @Description:
 * @Reference:
 * @Author: Crish
 * @CreateDate:2019-04-16-17:36
 * @Modify:
 **/
@Data
@Entity
@DynamicInsert
@DynamicUpdate
@EqualsAndHashCode(callSuper = true)
@Table(name="MES_QUEUE_ORDER_DETAIL")
@Api("生产队列明细")
public class MesQueueOrderDetail extends BaseBean {
    @Column(name="ORDER_NO")
    @ApiParam("工单号")
    private String orderNo;

    @Column(name="PART_NO")
    @ApiParam("物料号")
    private Integer partNo;

    @Column(name="SERIAL_NUMBER")
    @ApiParam("产品条码")
    private String serialNumber;

    @Column(name="SEQ")
    @ApiParam("队列明细序号")
    private Double seq;

    @Column(name="QTY")
    @ApiParam("数量")
    private Double qty;

    @Column(name="STATUS")
    @ApiParam("状态")
    private Integer status;

    @Column(name="WORK_TYPE")
    @ApiParam("生产类型")
    private String workType;

    @Column(name="PRODUCE_CATEGORY")
    @ApiParam("产品类型")
    private String produceCategory;

    public double getSeqVal() {
        return this.seq == null ? 0.0d : this.seq;
    }

    public double getQtyVal() {
        return this.qty == null ? 0.0d : this.qty;
    }

    public int getStatusVal() {
        return this.status == null ? 0 : this.status;
    }
}
