package cn.estsh.i3plus.pojo.mes.sqlpack;

import cn.estsh.i3plus.pojo.base.bean.BaseBean;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesPlanOrder;
import org.apache.commons.lang3.StringUtils;

/**
 * @Description:
 * @Reference: Mes 条件封装
 * @Author: Crish
 * @CreateDate:2019-04-22-14:58
 * @Modify:
 **/
public class MesHqlPack {

    /**
     * 通用查询条件
     * @param organizeCode
     * @return
     */
    public static DdlPackBean getAllBaseData(String organizeCode) {
        DdlPackBean packBean = new DdlPackBean();
        DdlPreparedPack.getStringEqualPack(organizeCode, "organizeCode", packBean);
        DdlPreparedPack.getNumEqualPack(CommonEnumUtil.IS_VAILD.VAILD.getValue(), "isValid", packBean);
        DdlPreparedPack.getNumEqualPack(CommonEnumUtil.IS_DEAL.NO.getValue(), "isDeleted", packBean);
        return packBean;
    }

    /**
     * 生产计划查询条件封装
     * @param mesPlanOrder
     * @return
     */
    public static DdlPackBean getPlanOrderCondition(MesPlanOrder mesPlanOrder) {
        DdlPackBean packBean = new DdlPackBean();
        DdlPreparedPack.getStringEqualPack(mesPlanOrder.getCustCode(), "organizeCode", packBean);
        DdlPreparedPack.getNumEqualPack(CommonEnumUtil.IS_VAILD.VAILD.getValue(), "isValid", packBean);
        DdlPreparedPack.getNumEqualPack(CommonEnumUtil.IS_DEAL.NO.getValue(), "isDeleted", packBean);

        if (StringUtils.isNotEmpty(mesPlanOrder.getOrderNo())) {
            DdlPreparedPack.getStringEqualPack(mesPlanOrder.getOrderNo(), "orderNo", packBean);
        }
        if (StringUtils.isNotEmpty(mesPlanOrder.getPartNo())) {
            DdlPreparedPack.getStringEqualPack(mesPlanOrder.getPartNo(), "partNo", packBean);
        }
        if (StringUtils.isNotEmpty(mesPlanOrder.getPlanType() + "")) {
            DdlPreparedPack.getNumEqualPack(mesPlanOrder.getPlanType(), "planType", packBean);
        }

        if (StringUtils.isNotEmpty(mesPlanOrder.getStatusVal() + "")) {
            DdlPreparedPack.getNumEqualPack(mesPlanOrder.getStatusVal(), "status", packBean);
        }
        if (StringUtils.isNotEmpty(mesPlanOrder.getStatusVal() + "")) {
            DdlPreparedPack.getStringEqualPack(mesPlanOrder.getCreateUser(), "createUser", packBean);
        }

        DdlPreparedPack.timeBuilder(
                mesPlanOrder.getStartTimeStart(),
                mesPlanOrder.getStartTimeEnd(),
                "startTime", packBean, true);
        DdlPreparedPack.timeBuilder(
                mesPlanOrder.getEndTimeStart(),
                mesPlanOrder.getEndTimeEnd(),
                "endTime", packBean, true);
        DdlPreparedPack.timeBuilder(
                mesPlanOrder.getCreateDateTimeStart(),
                mesPlanOrder.getCreateDateTimeEnd(),
                "createDateTime", packBean, true);
        // 排序
        DdlPreparedPack.getOrderByPack(new Object[]{"2"},new String[]{mesPlanOrder.getOrderByParam()} , packBean);
        DdlPreparedPack.getOrderDefault(mesPlanOrder);
        return packBean;
    }


}
